propellor-5.13: property-based host configuration management in haskell

Maintainer | 2016 Evan Cofsky <evan@theunixman.com>
Safe Haskell | None
Language | Haskell2010

Propellor.Property.Apt.PPA

Description

Personal Package Archives

Synopsis

- installed :: Property DebianLike
- data PPA = PPA {
  - ppaAccount :: String
  - ppaArchive :: String
  }
- addPpa :: PPA -> Property DebianLike
- data AptKeyId = AptKeyId {
  - akiName :: String
  - akiId :: String
  - akiServer :: String
  }
- addKeyId :: AptKeyId -> Property DebianLike
- data AptSource = AptSource {
  - asURL :: Url
  - asSuite :: String
  - asComponents :: [String]
  }
- data AptRepository
  - = AptRepositoryPPA PPA
  - | AptRepositorySource AptSource
- addRepository :: AptRepository -> Property DebianLike

# Documentation

installed :: Property DebianLike Source #

Ensure software-properties-common is installed.

data PPA Source #

Personal Package Archives are people's individual package contributions to the Buntish distro. There's a well-known format for representing them, and this type represents that. It's also an instance of `Show` and `IsString` so it can work with `OverloadedStrings`. More on PPAs can be found at https://help.launchpad.net/Packaging/PPA

Constructors

PPA |

Fields

- ppaAccount :: String

  The Launchpad account hosting this archive.

- ppaArchive :: String

  The name of the archive.

#### Instances

Instances details

Eq PPA Source # |
Instance details Defined in Propellor.Property.Apt.PPA Methods (==) :: PPA -> PPA -> Bool (/=) :: PPA -> PPA -> Bool
Ord PPA Source # |
Instance details Defined in Propellor.Property.Apt.PPA Methods compare :: PPA -> PPA -> Ordering (<) :: PPA -> PPA -> Bool (<=) :: PPA -> PPA -> Bool (>) :: PPA -> PPA -> Bool (>=) :: PPA -> PPA -> Bool max :: PPA -> PPA -> PPA min :: PPA -> PPA -> PPA
IsString PPA Source # |
Instance details Defined in Propellor.Property.Apt.PPA Methods fromString :: String -> PPA #
ConfigurableValue PPA Source # |
Instance details Defined in Propellor.Property.Apt.PPA Methods val :: PPA -> String Source #

addPpa :: PPA -> Property DebianLike Source #

Adds a PPA to the local system repositories.

data AptKeyId Source #

A repository key ID to be downloaded with apt-key.

Constructors

AptKeyId |

Fields

- akiName :: String
- akiId :: String
- akiServer :: String

#### Instances

Instances details

Eq AptKeyId Source # |
Instance details Defined in Propellor.Property.Apt.PPA Methods (==) :: AptKeyId -> AptKeyId -> Bool (/=) :: AptKeyId -> AptKeyId -> Bool
Ord AptKeyId Source # |
Instance details Defined in Propellor.Property.Apt.PPA Methods compare :: AptKeyId -> AptKeyId -> Ordering (<) :: AptKeyId -> AptKeyId -> Bool (<=) :: AptKeyId -> AptKeyId -> Bool (>) :: AptKeyId -> AptKeyId -> Bool (>=) :: AptKeyId -> AptKeyId -> Bool max :: AptKeyId -> AptKeyId -> AptKeyId min :: AptKeyId -> AptKeyId -> AptKeyId

addKeyId :: AptKeyId -> Property DebianLike Source #

Adds an `AptKeyId` from the specified GPG server.

data AptSource Source #

An Apt source line that apt-add-repository will just add to sources.list. It's also an instance of both `ConfigurableValue` and `IsString` to make using `OverloadedStrings` in the configuration file easier.

| FIXME there's apparently an optional "options" fragment that I've definitely not parsed here.

Constructors

AptSource |

Fields

- asURL :: Url

  The URL hosting the repository

- asSuite :: String

  The operating system suite

- asComponents :: [String]

  The list of components to install from this repository.

#### Instances

Instances details

Eq AptSource Source # |
Instance details Defined in Propellor.Property.Apt.PPA Methods (==) :: AptSource -> AptSource -> Bool (/=) :: AptSource -> AptSource -> Bool
Ord AptSource Source # |
Instance details Defined in Propellor.Property.Apt.PPA Methods compare :: AptSource -> AptSource -> Ordering (<) :: AptSource -> AptSource -> Bool (<=) :: AptSource -> AptSource -> Bool (>) :: AptSource -> AptSource -> Bool (>=) :: AptSource -> AptSource -> Bool max :: AptSource -> AptSource -> AptSource min :: AptSource -> AptSource -> AptSource
IsString AptSource Source # |
Instance details Defined in Propellor.Property.Apt.PPA Methods fromString :: String -> AptSource #
ConfigurableValue AptSource Source # |
Instance details Defined in Propellor.Property.Apt.PPA Methods val :: AptSource -> String Source #

data AptRepository Source #

A repository for apt-add-source, either a PPA or a regular repository line.

Constructors

AptRepositoryPPA PPA |
AptRepositorySource AptSource |

addRepository :: AptRepository -> Property DebianLike Source #

Adds an `AptRepository` using apt-add-source.